=== debian/changelog ===
traildb (0.6+dfsg1-2) unstable; urgency=medium

  [ ChangZhuo Chen (陳昌倬) ]
  * Update Vcs-* fields to salsa
  * d/copyright: Remove copyright year.

  [ Andreas Tille ]
  * Restrict architectures to any-amd64 x32
    Closes: #862919, #862920, #986250
  * Standards-Version: 4.7.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Replace transitional package pkg-config by pkgconf in Build-Depends
    (routine-update)
  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * watch file standard 4 (routine-update)
  * Add upstream metadata
  * Install static library into -dev package
  * d/not-installed: dh_missing now defaults to --fail-missing
  * d/watch: replace dh-make template
  * salsa-ci.yml: Do not build on i386

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 30 Aug 2025 00:42:34 +0800

traildb (0.6+dfsg1-1) unstable; urgency=medium

  * Initial release (Closes: #862791)

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 18 May 2017 11:46:04 +0800
