=== debian/control ===
Source: traildb
Priority: optional
Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
Build-Depends: debhelper-compat (= 13),
               libarchive-dev,
               libjudy-dev,
               pkgconf,
Standards-Version: 4.7.2
Section: database
Homepage: https://github.com/traildb/traildb
Vcs-Git: https://salsa.debian.org/debian/traildb.git
Vcs-Browser: https://salsa.debian.org/debian/traildb

Package: traildb-cli
Architecture: any-amd64 x32
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libtraildb0 (= ${binary:Version}),
Description: library to handle series of discrete events (cli tool)
 TrailDB is a highly optimized database library, written in C, which allows you
 to store and query trillions of discrete events quickly. In contrast to many
 other time-series databases, TrailDB focuses on discrete data, like events in
 a log file, which it can compress efficiently using a custom compression
 algorithm.
 .
 This package contains cli tool for traildb.

Package: libtraildb-dev
Architecture: any-amd64 x32
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libtraildb0 (= ${binary:Version}),
Description: library to handle series of discrete events (development files)
 TrailDB is a highly optimized database library, written in C, which allows you
 to store and query trillions of discrete events quickly. In contrast to many
 other time-series databases, TrailDB focuses on discrete data, like events in
 a log file, which it can compress efficiently using a custom compression
 algorithm.
 .
 This package contains development files for libtraildb.

Package: libtraildb0
Architecture: any-amd64 x32
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: library to handle series of discrete events
 TrailDB is a highly optimized database library, written in C, which allows you
 to store and query trillions of discrete events quickly. In contrast to many
 other time-series databases, TrailDB focuses on discrete data, like events in
 a log file, which it can compress efficiently using a custom compression
 algorithm.
 .
 This package contains library of traildb.
