=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%, dversionmangle=s/\+dfsg\d+$//" \
   https://github.com/traildb/traildb/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian debian/repack-waf
